﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using System.Windows.Media.Effects;
using System.Windows.Media.Imaging;


namespace SilverHSL
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }


        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Uri uri = new Uri(@"/SilverHSL;component/test.jpg", UriKind.Relative);
            BitmapImage bmi = new BitmapImage(uri);
            ImageBrush pic = new ImageBrush() { ImageSource = bmi };

            //        BlankEffect BE = new BlankEffect();
            //        BE.Bitmap1 = pic;
            //        button1.Effect = BE;
            EmbossEffect BE = new EmbossEffect();
            BE.Bitmap1 = pic;
            button1.Effect = BE;
        }
    }
    public class BlankEffect : ShaderEffect
    {
        DependencyProperty PixelColorProperty =
     DependencyProperty.Register(
       "PixelColor", typeof(Color),
         typeof(BlankEffect),
       new PropertyMetadata(Colors.White,
           PixelShaderConstantCallback(0)));
        public Color PixelColor
        {
            get
            {
                return (Color)GetValue(
                       PixelColorProperty);
            }
            set
            {
                SetValue(PixelColorProperty,
                                    value);
            }
        }

        public Brush Bitmap1
        {
            get
            {
                return
                    (Brush)GetValue(Bitmap1Property);
            }
            set { SetValue(Bitmap1Property, value); }
        }
        public static readonly
     DependencyProperty Bitmap1Property =
      ShaderEffect.
        RegisterPixelShaderSamplerProperty(
          "Bitmap1", typeof(BlankEffect), 1);

        public BlankEffect()
        {
            PixelShader pixelShader =
                         new PixelShader();
            Uri uri = new Uri(@"/SilverHSL;component/shader/shader1.ps", UriKind.Relative);
            pixelShader.UriSource = uri;
            this.PixelShader = pixelShader;
            UpdateShaderValue(Bitmap1Property);
        }
    }
    public class EmbossEffect : ShaderEffect
    {
        public Brush Bitmap1
        {
            get
            {
                return
                    (Brush)GetValue(Bitmap1Property);
            }
            set { SetValue(Bitmap1Property, value); }
        }

        public static
          readonly DependencyProperty
           Bitmap1Property = ShaderEffect.
            RegisterPixelShaderSamplerProperty(
              "Bitmap1", typeof(EmbossEffect), 0);

        public EmbossEffect()
        {
            PixelShader pixelShader =
                            new PixelShader();
            Uri uri = new Uri(@"/SilverHSL;component/shader/shader1.ps", UriKind.Relative);
            pixelShader.UriSource = uri;
            this.PixelShader = pixelShader;
            UpdateShaderValue(Bitmap1Property);
        }

    }
}
